//+------------------------------------------------------------------+
//|                                                 GreenRedGrey.mq4 |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 LightGray
#property indicator_color4 LightGray

//---- buffers
double Buffer1[],Buffer2[],Buffer3[],Buffer4[];

#define SkippedBars 39 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexBuffer(0,Buffer1);
   SetIndexLabel(0,NULL);
//----
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(1,Buffer2);
   SetIndexLabel(1,NULL);
//----
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(2,Buffer3);
   SetIndexLabel(2,NULL);
//----
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(3,Buffer4);
   SetIndexLabel(3,NULL);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Zone Trading                                                     |
//+------------------------------------------------------------------+
int start()
  {
   int    i;
   int    counted_bars=IndicatorCounted();
//----
   if(Bars<=SkippedBars) return(0);
//---- 
   i=Bars-SkippedBars-1;
   if(counted_bars>SkippedBars-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      // Green
      if ((iAO(Symbol(), Period(), i)>iAO(Symbol(), Period(), i+1))&&(iAC(Symbol(), Period(), i)>iAC(Symbol(), Period(), i+1)))
        {
         Buffer1[i]=High[i]; Buffer2[i]=Low[i]; Buffer3[i]=Low[i]; Buffer4[i]=Low[i];
         i--;
         continue;
        }
      // Red
      if ((iAO(Symbol(), Period(), i)<iAO(Symbol(), Period(), i+1))&&(iAC(Symbol(), Period(), i)<iAC(Symbol(), Period(), i+1)))
        {
         Buffer1[i]=Low[i]; Buffer2[i]=High[i]; Buffer3[i]=Low[i]; Buffer4[i]=Low[i];
         i--;
         continue;
        }
      // Gray
      Buffer1[i]=Low[i]; Buffer2[i]=Low[i]; Buffer3[i]=High[i]; Buffer4[i]=Low[i];
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+